//Class Code 1 for April 15, 2013

// jpg practice
// color separation based on threshhold value

final float THRESH_HOLD = 127;  // valid values = to 255

PImage pic;

void setup( )
{
  size( 640, 480 );
  pic = loadImage( "Flower1.jpg" );
  pic.loadPixels( );
  
  rectMode( CENTER );
  textSize( 18 );
  textAlign( CENTER, CENTER );
}

void draw( )
{
   image( pic, 0, 0 );
   instructions( );
} 

void keyPressed( )
{
   pic = loadImage( "Flower1.jpg" );
   pic.loadPixels( );
   float r, g, b;
   for ( int i = 0; i < pic.pixels.length; i++)
   {
      color c = pic.pixels[i];
      if ( key == 'r' )
      {
        r = red( c ); 
        g = 0; //green( c );
        b = 0; //blue( c );
        if ( r < THRESH_HOLD ) r = 0; else r = 255 ;
      }
      else if ( key == 'g' )
      {
        r = 0; 
        g = green( c );
        b = 0; 
        if ( g < THRESH_HOLD ) g = 0; else g = 255 ;
        
      }
      else if ( key == 'b' )
      {
        r = 0; 
        g = 0;
        b = blue( c ); 
        if ( b < THRESH_HOLD ) b = 0; else b = 255 ;     
      }
      else if ( key == ' ' )
      {
        r = red( c ); 
        g = green( c );
        b = blue( c );
        float average = (r + g + b ) / 3;
        r = g = b = average;     
      }
      else
      {
        r = red( c ); 
        g = green( c );
        b = blue( c );       
      }
      pic.pixels[i] = color( r, g, b );
   }
   
   pic.updatePixels( );

}

void instructions( )
{
  fill( 0 );
  rect( width/2, height*.05, width, height *.05 );
  fill( 255 );
  text( "[r]=>red  [g]=>green  [b]=>blue  [space]=>gray  [other]=>normal", width/2, height*.04);
}




