//Class Code 2 for April 15, 2013
//  Filtering the colors with a slider

PImage  pic;
String PIC_NAME = "Flower1.jpg";

float barX, barY, barHeight, barWidth;
color barColor;

float sliderX, sliderWidth;
color sliderColor;

float threshHold;

float r, g, b;
char colorChoice;
void setup( )
{
  size( 640, 480 );
  
  pic = loadImage( PIC_NAME);
  pic.loadPixels( );
  println( pic.width +  "  " + pic.height);
  rectMode( CENTER );
  noStroke( );
  textAlign( CENTER, CENTER );
  textSize( 14 );
  barX = width/2;
  barY = height*.90;
  barHeight = height*.04 ;
  barWidth  = width*.9;
  barColor = color( 255, 255, 0 );
  
  sliderX = height/2;
  sliderWidth = 5;
  sliderColor = color( 0 );
  threshHold = 127;
  
 
}

void draw( )
{
   image( pic, 0, 0, 640, 480 );
   drawSlider( );
   showText( );
} 

void keyPressed( )
{
    colorChoice = key;
         if( key == 'r' ) sliderColor = color( 255, 0, 0 );
    else if( key == 'g' ) sliderColor = color( 0, 255, 0 );
    else if( key == 'b' ) sliderColor = color( 0, 0, 255 );
    else if( key == ' ' ) sliderColor = color( 127 );
    else                  sliderColor = color( 0 );
}


void mouseMoved( )
{
   sliderX = constrain( mouseX, width*.05, width*.95 );
   threshHold = map( sliderX, width*.05, width*.95, 0, 255 ) ;
   
   pic = loadImage(PIC_NAME);
   pic.loadPixels( );
   
   for ( int i = 0; i < pic.pixels.length; i++)
   {
      color c = pic.pixels[i];
      if ( colorChoice == 'r' )  // red
      {
        r = red( c ); 
        g = 0;
        b = 0;
        if ( r < threshHold ) r = 0; else r = 255 ;
        pic.pixels[i] = color( r, g, b );
        pic.updatePixels( );
      }
      else if ( colorChoice == 'g' )  // green
      {
        r = 0; 
        g = green( c );
        b = 0; 
        if ( g < threshHold ) g = 0; else g = 255 ;
        pic.pixels[i] = color( r, g, b );
        pic.updatePixels( );
      }
      else if ( colorChoice == 'b' )  // blue
      {
        r = 0; 
        g = 0;
        b = blue( c ); 
        if ( b < threshHold ) b = 0; else b = 255 ; 
        pic.pixels[i] = color( r, g, b ); 
        pic.updatePixels( );   
      }
      else if ( colorChoice == ' ' )  // gray
      {
        r = red( c ); 
        g = green( c );
        b = blue( c );
        float average = (r + g + b ) / 3;
        r = g = b = average;  
        pic.pixels[i] = color( r, g, b );  
        pic.updatePixels( ); 
      }
   }


}

void drawSlider( )
{
   fill( barColor );
   rect( barX, barY, barWidth, barHeight );
   fill( sliderColor );
   rect( sliderX, barY, sliderWidth, barHeight );
}

void showText( )
{
   fill( 0 );
   rect( barX, barY + barHeight + 3, barWidth, barHeight );
   fill( 255 );
   text( "KEYS:  [r]=>red [g]=>green [b]=>blue [space]=>gray [other]=>original",
         barX, barY + barHeight + 3);
   
}
